﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;

namespace csharp2vala
{
    class Glade
    {

        private FileFunctions FF = new FileFunctions();
        public bool noexpandflag = false; 

        public void FormToGlade(String projectFolder, String outPath)
        {
            FF.log("Converting WinForm to project.glade...");

            
            //FF.log(projectFolder);

            String inFile = projectFolder + "/Form1.Designer.cs";
            String outFile = outPath + "/project.glade";
            

            String[] theForm = FF.ReadAllLines(inFile);

            String thenamespaceorig = theForm[0];
            thenamespaceorig = thenamespaceorig.Replace("namespace ", "");

            String thenamespace = thenamespaceorig.Substring(0, 1).ToLower();
            String thesub = "";
            for(int n=1;n<thenamespaceorig.Length;n++){
                thesub = thenamespaceorig.Substring(n,1);
                if(! thesub.ToLower().Equals(thesub)){
                    thenamespace = String.Concat (thenamespace , "_");
                    thenamespace = String.Concat(thenamespace, thesub.ToLower());
                    //thesub.ToLower;
                }else{
                    thenamespace = String.Concat(thenamespace, thesub.ToLower());
                }

            }


            thenamespace = String.Concat(thenamespace, "_form1");

            ArrayList o = new ArrayList();


            //-------- build head of gladefile -------

            o.Add("<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>");
            o.Add("<!DOCTYPE glade-interface SYSTEM \"glade-2.0.dtd\">");
            o.Add("<!--Generated with glade3 3.0.3 on Sat Mar 21 04:00:14 2009 by csharp2vala-->");
            o.Add("<glade-interface>");
            o.Add("  <widget class=\"GtkWindow\" id=\"window1\">");
            o.Add("    <property name=\"visible\">True</property>");
            o.Add("    <signal name=\"destroy\" handler=\"" + thenamespace + "_on_window1_destroy\"/>");
            o.Add("    <child>");
            o.Add("      <widget class=\"GtkHBox\" id=\"hbox1\">");
            o.Add("        <property name=\"visible\">True</property>");
            o.Add("        <property name=\"border_width\">10</property>");
            o.Add("        <property name=\"spacing\">5</property>");
            o.Add("        <child>");

            o.Add("          <placeholder/>");
            o.Add("        </child>");
            o.Add("        <child>");

            o.Add("          <widget class=\"GtkVBox\" id=\"vbox1\">");
            o.Add("          <property name=\"spacing\">6</property>");
            o.Add("            <property name=\"visible\">True</property>");
            //-- add the children here

            String theline;
            int i1;
            int i2;
            String widgetname;

            String[] widgetinfo;
            String widgettype;

            for(int i=0; i<theForm.Length;i++){
                theline = theForm[i];
                //FF.log("-> " + theline);

                if(theline.Contains("= new System.Windows.Forms.")){
                    i1 = theline.IndexOf("this.") + 5;
                    i2 = theline.IndexOf(" = ");
                    widgetname = theline.Substring(i1, i2-i1);
                    //FF.log("--> " + widgetname);

                    //-- we support only some widgets --
                    noexpandflag = false;
                    widgetinfo  = is_valid_widget(theline , widgetname , theForm, thenamespace);
                    if(!widgetinfo[0].Equals("")){
                        widgettype = widgetinfo[0];
                        //FF.log("---> " + widgettype);


                        o.Add("        <child>");
                        //-- type --
                        o.Add("          <widget class=\"" + widgettype + "\" id=\"" + widgetname + "\">");
                        //-- property --

                        for (int n = 1; n < widgetinfo.Length;n++ )
                        {
                            if (!widgetinfo[n].Equals(""))
                            {
                                o.Add(widgetinfo[n]);
                            }
                        }

                        o.Add("          </widget>");
                        if(noexpandflag){
                            o.Add("          <packing>");
                            o.Add("            <property name=\"expand\">False</property>");
                            o.Add("          </packing>");
                        }
                        o.Add("        </child>");


                    }
                }

            }

            //-------- build foot of gladefile -------

            o.Add("          </widget>");
            o.Add("          <packing>");
            o.Add("            <property name=\"position\">1</property>");
            o.Add("          </packing>");


            o.Add("      </child>");
            o.Add("      </widget>");
            o.Add("    </child>");
            o.Add("  </widget>");
            o.Add("</glade-interface>");


            String[] outList = (string[])o.ToArray(typeof(string));
            FF.WriteAllLines(outFile, outList);

        }
        public String[] is_valid_widget(String s1, String widgetname, String[] theform, String thenamespace)
        {

            String[] ret = new String[30];
            //ret[0] = ""; // type
            //ret[1] = ""; // property
            //ret[2] = ""; // eventhandler
            for (int i = 0; i< ret.Length; i++){
                ret[i] = ""; 
            }
            int rc = 2; //counter
            int i1;

            String optionvalue;

            //-- Button + optional label --

            if (s1.Contains("Forms.Button()")){
                ret[0] = "GtkButton";
                noexpandflag = true;
                ret[1] = "		    <property name=\"visible\">True</property>";

                //-- find label --
                for (int i = 0; i< theform.Length; i++){
                    if(theform[i].Contains("this." + widgetname + ".Text = ")){
                        i1 = theform[i].IndexOf("= \"") + 3;
                        optionvalue = theform[i].Substring(i1, theform[i].Length-i1-2);
                        ret[rc] = "            <property name=\"label\" translatable=\"yes\">" + optionvalue + "</property>";
                        rc++;
                        break;
                    }
                }
                //-- find eventhandler (there may be more in fact)--
                for (int i = 0; i < theform.Length; i++)
                {
                    if (theform[i].Contains("this." + widgetname + ".Click "))
                    {
                        i1 = theform[i].IndexOf("(this.") + 6;
                        optionvalue = theform[i].Substring(i1, theform[i].Length - i1 - 2);
                        ret[rc] = "            <signal name=\"clicked\" handler=\"" + thenamespace + "_" + optionvalue + "\"/>";
                        rc++;
                        break;
                    }
                }

 
                return ret;
            }

            //-- TextBox --
            if (s1.Contains("Forms.TextBox()"))
            {

                //-- must check here, if entry or textview --

                ret[0] = "GtkEntry";
                ret[1] = "		    <property name=\"visible\">True</property>";
                for (int i = 0; i < theform.Length; i++)
                {
                    if (theform[i].Contains("this." + widgetname + ".Multiline = true;"))
                    {
                        ret[0] = "GtkTextView";
                        break;
                    }
                }

                //-- find label --
                for (int i = 0; i < theform.Length; i++)
                {
                    if (theform[i].Contains("this." + widgetname + ".Text = "))
                    {
                        i1 = theform[i].IndexOf("= \"") + 3;
                        optionvalue = theform[i].Substring(i1, theform[i].Length - i1 - 2);
                        ret[rc] = "            <property name=\"text\" translatable=\"yes\">" + optionvalue + "</property>";
                        rc++;
                        break;
                    }
                }

                //-- find eventhandler (there may be more in fact)--
                // TextChanged only available for entry!
                if (ret[0].Equals("GtkEntry"))
                {
                    for (int i = 0; i < theform.Length; i++)
                    {
                        if (theform[i].Contains("this." + widgetname + ".TextChanged "))
                        {
                            i1 = theform[i].IndexOf("(this.") + 6;
                            optionvalue = theform[i].Substring(i1, theform[i].Length - i1 - 2);
                            ret[rc] = "            <signal name=\"changed\" handler=\"" + thenamespace + "_" + optionvalue + "\"/>";
                            rc++;
                            break;
                        }
                    }
                }


                return ret;

            }

            return ret;
        }
    }
}
